Subject: Re: iSCSI: plugfest4 issues

From: "Julian Satran" <[email-masked]>
Date: Thu, 1 Aug 2002 10:25:48 +0300

Santosh,

I think that this behaviour should be specified by SPC3. I looked (again) 
into the FCP docs and like iSCSI they do not say anything beyond
iSCSI says. Like iSCSI they specify that the field is valid when the Oo/Uu 
bits are set but nothing about how those bits relate to status.
SPC says nothing about that either  (beyond that the bits set are not 
necessarily an indication of error). 

Julo

Santosh Rao <[email-masked]>
Sent by: [email-masked]
08/01/2002 03:44 AM

        To:     IPS Reflector <[email-masked]>, Julian Satran/Haifa/IBM@IBMIL, 
[email-masked]
        cc:     Robert Snively <[email-masked]>, T10 Reflector <[email-masked]>
        Subject:        Re: iSCSI: plugfest4 issues

Julian & Robert [Russell],

I raised the same query regarding RESID for FCP/FCP-2 this time last
year. The response I got for FCP/FCP-2 was that RESID information shall
be valid, regardless of the scsi status returned. The RESID field, can
be checked by the scsi transport drivers independent of the SCSI STATUS.

I have enclosed the T10 response from Rob Snivelly below on that issue.
As per FC-PLDA, the RESID information is valid, regardless of the scsi
status returned by the device. 

An example of this is the case of "NO SENSE" or "RECOVERED ERROR" check
condition, when the data transfer may have taken place and a CHECK
CONDITION is returned. Also, for other CHECK CONDITION status', partial
data transfer may have taken place and hence, resid information should
be present.

It would be good to maintain consistent behaviour across the scsi
transports in this regard, since protocol bridging from iscsi to FCP
domain would expect RESID information in the FCP domain, regardless of
scsi status.

This also allows scsi transports to remain free of SCSI command set
details. (ex : the scsi transport drivers do not need to parse for CHECK
CONDITION or GOO status information.)

Thanks,
Santosh

-------------------------------------------------------------------------

Subject: Re: iSCSI: plugfest4 issues
Date:    Thu, 1 Aug 2002 02:52:19 +0300
From:   "Julian Satran" <[email-masked]>
To:     "Robert D. Russell" <[email-masked]>
CC:     [email-masked]

Bob, 

Thanks - some comments in text. Julo 

  "Robert D. Russell" <[email-masked]> 
 
Julian:

Four issues came up today at the iSCSI plugfest:

1. A question about whether or not the Residual Count field and the
  appropriate O and U bits need to be computed on all SCSI Response
  PDUs, regardless of the values in the Status and/or Response fields.

  One point of view says that the Residual Count field and the O and U
  bits appear to be strictly iSCSI values that are derived by the
  iSCSI target layer from the ExpectedDataTransferLength field of the
  SCSI Command PDU and the DataSegmentLength fields of the DataIn or
  DataOut PDUs sent as part of this command.  Therefore ,the iSCSI
  target always computes a Residual Count value without regard to the
  Status and/or Response fields, since these are SCSI values.

  The other point of view says that the Residual Count field, and the
  O and U bits, need only be set when the Status and Response fields
  indicate that the command was completed at the target with a GOOD
  Status, and the target does not have to compute or set the Residual
  Count field and the O or U bits for other values of the Status and/or
  Response fields.

  Which is it?  In any case, could this be clarified somewhere in the
  standard, most likely in section 9.4.4.

+++ Residual count fields are in fact carrioed over from the SCSI layer.
I know that none of the SCSI docs specifies
exactly their behavior and it strikes me as a bad idea to have protocols
specify them. 
The values should be valid any time the target decides to put them in. 
+++

-------------------------------------------------------------------------
Subject: RE: FCP_RSP Residual Checking.
Date:    Thu, 5 Jul 2001 13:18:42 -0700
From:    Robert Snively <[email-masked]>
To:      "'Santosh Rao'" <[email-masked]>, 
         T10 Reflector <[email-masked]>, 
         Fibre Channel T11 reflector <[email-masked]>

Robert Snively wrote:
> 
> >  Is the target required to initialize the fields FCP_RESID_UNDER,
> >  FCP_RESID_OVER & FCP_RESID when any I/O is completed
> >  without the data phase having transferred exactly
> >  FCP_DL bytes, regardless of the SCSI Status being returned ?
> 
> >  When the target generates a CHECK CONDITION on an I/O
> >  and may have returned less than FCP_DL bytes in the data
> >  phase for that I/O, is it
> >  required to set the FCP_RESID_UNDER to 1 and indicate the number of
> >  bytes not transferred in the FCP_RESID field?
> 
> The intent is that the answer to your second question is:
> FCP_RESID should appropriately regardless of the SCSI Status
> being returned.  The classic errors of that class are those
> involving successful completion with reporting, like
> the "NO SENSE" and "RECOVERED ERROR" series of errors.
> 
> >
> >  What is the behaviour initiators can expect under the above
> >  condition ?
> 
> The intent is that there be no conflict.  I believe that FCP-2
> was a bit less bald than FC-PLDA in stating the requirement.
> 
> >  Is there a conflict in the behaviours described by FCP/FCP-2
> >  & FC-PLDA ?
> >
> 
> Bob Snively                        e-mail:    [email-masked]
> Brocade Communications Systems     phone:  408 487 8135
> 1745 Technology Drive
> San Jose, CA 95110
> 
> >  -----Original Message-----
> >  From: Santosh Rao [mailto:[email-masked]]
> >  Sent: Thursday, July 05, 2001 12:15 PM
> >  To: T10 Reflector; Fibre Channel T11 reflector
> >  Subject: FCP_RSP Residual Checking.
> >
> >
> >  All,
> >
> >  I've got a question on target behaviour while sending a
> >  CHECK CONDITION
> >  SCSI status in its FCP_RSP IU.
> >
> >  Is the target required to initialize the fields FCP_RESID_UNDER,
> >  FCP_RESID_OVER & FCP_RESID when any I/O is completed without the data
> >  phase having transferred exactly FCP_DL bytes, regardless of the SCSI
> >  Status being returned ?
> >
> >  When the target generates a CHECK CONDITION on an I/O and may have
> >  returned less than FCP_DL bytes in the data phase for that I/O, is it
> >  required to set the FCP_RESID_UNDER to 1 and indicate the number of
> >  bytes not transferred in the FCP_RESID field?
> >
> >  FC-PLDA Section 8.2.4.1 states that :
> >  "SCSI targets that transfer less than FCP_DL bytes during
> >  the FCP_DATA
> >  IUs shall set the FCP_RESID_UNDER to 1".
> >
> >  No exceptions are specified in the case of a CHECK CONDITION in the
> >  above definition, implying that FCP_RSP residual checking can be
> >  performed irrespective of the SCSI Status that was returned in the
> >  FCP_RSP.
> >
> >  However, the wording descriptions of FCP_RESID_UNDER,
> >  FCP_RESID_OVER &
> >  FCP_RESID in SCSI-FCP & FCP-2 are not as stringent as
> >  FC-PLDA and do not
> >  mandate that FCP_RESID_UNDER shall be set when the data
> >  transferred is <
> >  FCP_DL.
> >
> >  What is the behaviour initiators can expect under the above
> >  condition ?
> >  Is there a conflict in the behaviours described by FCP/FCP-2
> >  & FC-PLDA ?
> >
> >  Thanks,
> >  Santosh Rao
> >

-- 
Education is when you read the fine print. 
Experience is what you get if you don't.

---

From: Santosh Rao <[email-masked]>
Date: Thu, 01 Aug 2002 10:11:48 -0700

Julian,

I agree with you that the wording should be sufficient as called out in
Section 9.4 description of the bits and the resid field.

However, in observance of the fact that non-interopability has been
noticed in this area, it may help to tighten the wording for the
description of the o/O and u/U bits in the "SCSI Response" description
in Section 9.4. Perhaps, the use of "MUST" directive when calling out
the condition for the u/U/o/O bits to be set would help.

Also, In Section 9.4.4, instead of :
"The Residual Count field is only valid in the case where either the U
bit or the O bit is set."

I suggest :
"The Residual Count field MUST be valid when either the U or the O bit
is set".

Similar wording for the Bi-di read residual count.

Thanks,
Santosh

Julian Satran wrote:
> 
> Santosh,
> 
> I think that this behaviour should be specified by SPC3. I looked
> (again) into the FCP docs and like iSCSI they do not say anything
> beyond
> iSCSI says. Like iSCSI they specify that the field is valid when the
> Oo/Uu bits are set but nothing about how those bits relate to status.
>  <[email-masked]>                     To:        IPS Reflector
>  Sent by:                          <[email-masked]>, Julian
>  [email-masked]        Satran/Haifa/IBM@IBMIL,
>                                    [email-masked]
>  08/01/2002 03:44 AM                       cc:        Robert Snively
>                                    <[email-masked]>, T10
>                                    Reflector <[email-masked]>
>                                            Subject:        Re: iSCSI:
>                                    plugfest4 issues
> 
> 
> 

-- 
Finish each day and be done with it.  You have done what you could;
Some blunders and absurdities have crept in; Forget them as soon as you
can.
Tomorrow is a new day; You shall begin it serenely and with too high a
spirit 
to be encumbered with your old nonsense.